<?php

// $Id: progressbar.php,v 1.3 2002/11/01 11:24:21 zaphodbrx Exp $

	// Usage:	$filename = "This is a very long name of a common file[XXX].mpg";
	//			echo '<img src="progressbar.php?filename='.urlencode($filename).'">';

	require ("config.inc.php");

	header("Content-type: image/png");

	$filename = stripslashes($filename);
	$filename = urldecode($filename);

	$flag=0;

	// Use a cache to determine what files are being downloaded and their numbers
	if (!file_exists($tempdir.'part.cache')) {
		touch($tempdir.'part.cache');
	}
	$cache=file($tempdir.'part.cache');
	for ($x=0; $x<=sizeof($cache)-1; $x++) {
		if (preg_match("/".bin2hex($filename)."/",bin2hex($cache[$x]))) {
			preg_match("/----(.+)$/",$cache[$x],$temp_filenum);
			$file_num = $temp_filenum[1];
			$flag=1;
		}
	}

	$x=0;
	if ($flag==1) {
		$fp = popen ($donkeypath.'info '.$file_num.'', "r");
		while (!feof($fp)) {
			$buffer = fgets($fp,1024);		// The lines are shorter than 1024 anyway
			if (preg_match("/^file size = ([0-9]+) /",$buffer,$temp_filesize))
				$filesize=$temp_filesize[1];

			if (preg_match("/^gap[ ]+[0-9]+ from[ ]+([0-9]+) to[ ]+([0-9]+) /",$buffer,$gap)) {
				list(,$gapmin[$x],$gapmax[$x]) = $gap;
				unset ($gap);
				$x++;
			}
		}
		$x--;
		pclose($fp);
	} else {
		$dirhandle=opendir($tempdir);
		// Traverse through file names in $tempdir to find $file_num.part.met
		while (($file = readdir($dirhandle)) && ($flag==0)) {
			if (preg_match('/([0-9]+).part.met/',$file,$metid)) {
				$file_num = $metid[1];
				// Get info on $file_num to check the 'real' filename
				$fp = popen ($donkeypath.'info '.$metid[1], "r"); 
				$x=0;
				while (!feof ($fp)) {
					$buffer = fgets($fp,4096);		// The lines are shorter than 1024 anyway
					if (($flag==0) && (strstr($buffer,$filename))) {
						$flag=1;
						// Add the file into the cache
						$fpo = fopen($tempdir.'part.cache', "a+");
						fwrite($fpo,$filename."----".$file_num."\n");
						fclose($fpo);
					}
					if ($flag==1) {
						if (preg_match("/file size = (.+) \(.+\)/",$buffer,$temp_filesize))
							$filesize=$temp_filesize[1];

						if (preg_match("/^gap[ ]+[0-9]+ from[ ]+([0-9]+) to[ ]+([0-9]+) /",$buffer,$gap)) {
							list(,$gapmin[$x],$gapmax[$x]) = $gap;
							unset($gap);
							$x++;
						}
					}
				}
				$x--;
				pclose($fp);
			}
		}
	}

	if ($flag==1) {
		// Create Image
		$im = ImageCreate(500,15);

		$back_color = ImageColorAllocate($im, 113, 167, 96);
		$gaps_color = ImageColorAllocate($im, 212, 185, 133);
		$bord_color = ImageColorAllocate($im, 0, 0, 0);

		// Mark the gaps
		for ($y=0; $y<=$x; $y++) {
			$left = round(($gapmin[$y]/$filesize)*500);
			$right = round(($gapmax[$y]/$filesize)*500);
			ImageFilledRectangle($im, $left, 0, $right, 14, $gaps_color);
		}

		// Draw a border
		ImageRectangle($im, 0, 0, 499, 14, $bord_color);

		// Dump the image data into this file
		ImagePNG($im);

		// Destroy Image in memory
		ImageDestroy($im);
	} else {
		// In case of an error - paint it in RED!
		$im = ImageCreate(500,15);
		$back_color = ImageColorAllocate($im, 200, 0, 0);
		$bord_color = ImageColorAllocate($im, 0, 0, 0);
		ImageFilledRectangle($im, 5, 5, 495, 10, $back_color);
		ImageRectangle($im, 0, 0, 499, 14, $bord_color);
		ImagePNG($im);
		ImageDestroy($im);
	}
?>
