<?php

// $Id: functions.inc.php,v 1.7 2002/11/01 11:24:21 zaphodbrx Exp $

$PHPD_Version="0.20 boogie";
set_time_limit(0);

function sendcommand($command) {
	global $cfgServer;
	global $cfgPort;
	global $timefactor;
	
	$handle = fsockopen($cfgServer, $cfgPort);

	if(!$handle) {
		echo "no connection to eDonkey or Overnet\n";
		exit();
	}

	fputs($handle, $command."\n");
	fclose ($handle);
	usleep(($timefactor*300000));
}

function inttostr($ip) {
	$str = "";
	for ($i = 0; $i < 4; $i++) {
		if ($i)
			$str = ".".$str;
		$str = ($ip & 0x000000FF).$str;
		$ip = $ip >> 8;
	}
	return $str;
}

function kommazahlform($wert) {
	$wert=preg_replace("/\./",",",$wert); //Punkt durch Komma erstetzen
	$gesplittet=split(",",$wert);  // Am Komma aufsplitten
	if (strlen($gesplittet[1])<2 && $gesplittet[1]<>"")
		$gesplittet[1]=$gesplittet[1]."0"; // bei einer Nachkommastelle: 0 einfuegen
	if ($gesplittet[1]=="")
		$gesplittet[1]="00"; // bei keiner Nachkommastelle: 00 einfuegen
	if (strlen($gesplittet[0])>6) {     // wenn zahl vor komma mehr als drei stellen hat: punkt einfuegen
		$gesplittet[0]=preg_replace("/([0-9][0-9][0-9])([0-9][0-9][0-9])$/",".\\1.\\2",$gesplittet[0]);
	} elseif (strlen($gesplittet[0])>3) {     // wenn zahl vor komma mehr als drei stellen hat: punkt einfuegen
		$gesplittet[0]=preg_replace("/([0-9][0-9][0-9])$/",".\\1",$gesplittet[0]);
	}

	$wert=join(",",$gesplittet);  // Zahl wieder zusammenfuegen
	return ($wert);
}

function timeformat($num_secs) {
	$eta["hours"] = intval(intval($num_secs) / 3600);

	$eta["minutes"] = intval(intval($num_secs-($eta["hours"]*3600)) / 60);
	if ($eta["minutes"] < 10) {
		$eta["minutes"] = "0".$eta["minutes"];
	}

	$eta["seconds"] = intval($num_secs-($eta["hours"]*3600)-($eta["minutes"]*60));
	if ($eta["seconds"] < 10) {
		$eta["seconds"] = "0".$eta["seconds"];
	}
	return $eta;
}

function sortfunction ($a, $b) {
	global $sort_opt;
	global $direct;

	$wert = strnatcasecmp($a[$sort_opt],$b[$sort_opt]);

	if ($direct=="DESC") {
		if ($wert > 0) {
			$return = -1;
		} elseif($wert < 0) {
			$return = 1;
		} else {
			$return = 0;
		}
	} else {
		$return=$wert;
	}
	return $return;
}

function SetHeader() {
   #global $totalspeed;
   global $bgcolor;
   global $fontcol;
   global $face;
   global $fontsize;
   global $alinkcol;
   global $vlinkcol;
   global $linkcol;
   global $stylesheet;
   global $donkeypath;
   global $logfile;
   global $tempdir;
   global $PHPD_Version;
   global $viewd_javascript;
   global $USEOvernet;

   $status="";

   echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
   <HTML>
   <HEAD>
      <TITLE>PHPDonkey '.$PHPD_Version.'</TITLE>
      <META HTTP-EQUIV="Expires" CONTENT="Tue, 01 Jan 1980 1:00:00 GMT">
      <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
      <LINK REL="SHORTCUT ICON" HREF="'.dirname($PHP_SELF).'/favicon.ico">
   ';

   if (strtolower($stylesheet)=="yes") {
      echo'
      <link rel="stylesheet" type="text/css" href="style.php">
      ';
   }

   if ($viewd_javascript==1) {
      echo '
      <script language="javascript">
      <!--
      var confirmMsg = "Do you really want to cancel this download";
      function confirmLink(theLink, theFile)
      {
         var is_confirmed = confirm(confirmMsg + " :\n\n" + theFile);
         parent.location.reload(true);
         return is_confirmed;
      } //-->
      </script>
      ';
   }

   echo '
   </HEAD>

   <BODY bgcolor="'.$bgcolor.'" link="'.$linkcol.'" vlink="'.$vlinkcol.'" alink="'.$alinkcol.'">
   <FONT color="'.$fontcol.'" face="'.$face.'" size="'.$fontsize.'">
   ';

   flush();

   sendcommand("g");
   usleep(($timefactor*100000));

   $log = file ($donkeypath.$logfile);

   for ($x=0; $x<=sizeof($log)-1; $x++) {
      $oldprompt=$prompt;
      if (preg_match("/^> /",$log[$x]))
         $prompt=$x;
   }
   for ($x=$oldprompt; $x<=$prompt; $x++) {
      $status=$status." ".preg_replace("/^[> ]+/","",$log[$x]);
   }


#check if overnet is running
   if (preg_match("/ID: (.+)\n Users: (.+)Files: ([0-9]+)/",$status,$statarr))
      list (,$STclientid,$STusers,$STfiles) = $statarr;
   if ( !empty($STclientid)){
#      $STconnectedto = "Using Overnet";
      $USEOvernet = "1";
   } 
   else{
   if (preg_match("/ClientID: (.+)\n Connected to: (.+)\n Users: (.+)Files: ([0-9]+)/",$status,$statarr))
      list (,$STclientid,$STconnectedto,$STusers,$STfiles) = $statarr;
   }
#   if (preg_match("/ClientID: (.+)\n Connected to: (.+)\n Users: (.+)Files: ([0-9]+)/",$status,$statarr))
#      list (,$STclientid,$STconnectedto,$STusers,$STfiles) = $statarr;
   ##################
   $status = "";
   sendcommand("vd");

   $log = file ($donkeypath.$logfile);
   for ($x=0; $x<=sizeof($log)-1; $x++) {
      $oldprompt=$prompt;
      if (preg_match("/^> /",$log[$x]))
         $prompt=$x;
   }
   for ($x=$oldprompt; $x<=$prompt; $x++) {
      $status=$status." ".preg_replace("/^[> ]+/","",$log[$x]);
   }
   if (preg_match("/Total: (.+)/",$status,$statarr))
      list (,$STtotalspeed_down) = $statarr;
   #print("total_func_down".$status."<br>");
   #print("total_func_down".$STtotalspeed_down."<hr><br>");
   #####################
   $status = "";
   sendcommand("vu");




   $log = file ($donkeypath.$logfile);
   for ($x=0; $x<=sizeof($log)-1; $x++) {
      $oldprompt=$prompt;
      if (preg_match("/^> /",$log[$x]))
         $prompt=$x;
   }
   for ($x=$oldprompt; $x<=$prompt; $x++) {
      $status=$status." ".preg_replace("/^[> ]+/","",$log[$x]);
   }
   if (preg_match("/Total: (.+)/",$status,$statarr))
      list (,$STtotalspeed_up) = $statarr;
   #print("total_func_up".$status."<br>");
   #print("total_func_up".$STtotalspeed_up."<hr><br>");
   #####################
## edit Header String for Overnet
if ($USEOvernet == "1")
{
 $SERVER="Overnet";
 $CLIENT="Client-ID:";
}
else
{
 $SERVER="Server:";
 $CLIENT="Client:";
}
   echo '<form name=statusform id=statusform>
   <span style="font-size:8pt;">
   <table cellspacing=0 cellpadding=1 border=0>
   <tr>
      <td rowspan=2>';
   if (empty($USEOvernet))
   echo '<a href="commandsend.php?command=x" target=commandsend><img src="pics/cancel.gif" alt="disconnect from server" width=12 height=13 border=0></a>';
echo '
     </td>
      <td rowspan=2>&nbsp;</td>
      <td><b><font color="'.$fontcol.'" face="'.$face.'" size='.$fontsize.'><span style="font-size:8pt;"> '.$SERVER.' </span></font></b></td> <td>'; 
   if (empty($USEOvernet))
   {
   echo '<input type=text id=STconnectedto name=STconnectedto style="font-size:8pt;" size=22 width=22 class=hidden value="'.$STconnectedto.'" readonly>';
   } 
echo '</td>
      <td><b><font color="'.$fontcol.'" face="'.$face.'" size='.$fontsize.'><span style="font-size:8pt;">Users:</span></font></b></td> <td><input type=text id=STusers       name=STusers       style="font-size:8pt;" size=22 width=22 class=hidden value="'.$STusers.'" readonly></td>
      <td><b><font color="'.$fontcol.'" face="'.$face.'" size='.$fontsize.'><span style="font-size:8pt;">Files:</span></font></b></td> <td><input type=text id=STfiles       name=STfiles       style="font-size:8pt;" size=22 width=22 class=hidden value="'.$STfiles.'" readonly></td>
   </tr>
   <tr>
      <td><b><font color="'.$fontcol.'" face="'.$face.'" size='.$fontsize.'><span style="font-size:8pt;"> '.$CLIENT.' </span></font></b></td><td><input type=text id=STclientid    name=STclientid    style="font-size:8pt;" size=22 width=22 class=hidden value="'.$STclientid.'" readonly></td>
      <td><b><font color="'.$fontcol.'" face="'.$face.'" size='.$fontsize.'><span style="font-size:8pt;">Space:</span></font></b></td> <td><input type=text id=STdiskspace   name=STdiskspace   style="font-size:8pt;" size=22 width=22 class=hidden value="'.number_format(diskfreespace($tempdir)/1024,0,'','').' kb" readonly></td>
      <td><b><font color="'.$fontcol.'" face="'.$face.'" size='.$fontsize.'><span style="font-size:8pt;">Total down/up:</span></font></b></td> <td><input type=text id=STtotalspeed  name=STtotalspeed  style="font-size:8pt;" size=22 width=22 class=hidden value="'.$STtotalspeed_down.' / '.$STtotalspeed_up.'" readonly></td>
   </tr>
   </table></span><hr size=1 noshade></form>
   ';

   flush();
}

function hex2bin($data) {
	$len = strlen($data);
	for($i=0; $i<$len; $i+=2) {
		$newdata .= pack("C",hexdec(substr($data,$i,2)));
	}
	return $newdata;
}

function strarray($in_string,$step) {
	if (!($in_string)) {
		return 0;
	}
	$t=0;
	for ($i=0; $i<=(strlen($in_string)-1); $i++) {
		$current_char = substr($in_string, ($i*$step), $step);
		$string_array[$i] = $current_char;
	}

	return $string_array;
}

function partinfo($filename) {
	$fp = fopen ($filename,'r');

	$contents = fread ($fp, filesize ($filename));

	fclose ($fp);
	$hexcontents=bin2hex($contents);
	$hexarray=strarray($hexcontents,2);
	$contarray=strarray($contents,1);

	// ------- File ID ------------------------
	$id="";
	for ($x=5;$x<=20;$x++){
		$id.=$hexarray[$x];
	}
	$return["id"]=$id;

	// ---------- Number of Hashes ------------------
	unset ($numhash);
	$numhash=hexdec($hexarray[22].$hexarray[21]);
	$return["numhash"]=$numhash;

	// ----------- Display all Hashes ----------------
	$start=23;
	for ($y=0;$y<=$numhash-1;$y++) {
		$first="";
		for ($x=$start;$x<=($start+15);$x++) {
			$first.=$hexarray[$x];
		}
		$start=$x;
	}

	// ------------ Number of Meta-Tags ----------------
	$t=0;
	for ($x=$start;$x<=$start+3;$x++) {
		$num_meta[$t]=$hexarray[$x];
		$t++;
	}
	$nums=hexdec(join("",array_reverse($num_meta)));
	$return["num_meta"]=$nums;
	$start=$x;

	// ------------ Display Meta-Tags -----------------
	for ($y=0;$y<=$nums-1; $y++){
		// Tag-Type
		$type[$y]=$hexarray[$start];
		$start++;
		$return["type"][$y]=$type[$y];

		// Name Length
		unset ($num_meta);
		$t=0;
		for ($x=$start;$x<=$start+1;$x++) {
			$num_meta[$t]=$hexarray[$x];
			$t++;
		}
		$name_length[$y]=hexdec(join("",array_reverse($num_meta)));
		$start=$x;

		if ($name_length[$y]==1) {
			$name_string[$y].=hexdec($hexarray[$start]);
			$start++;
		} else {
			for ($x=$start;$x<=$start+$name_length[$y]-1;$x++) {
				$name_string[$y].=hex2bin($hexarray[$x]);
			}
			$start=$x;
		}
		$return["name"][$y]=$name_string[$y];

		if ($type[$y]=="02") {
			unset ($num_meta);
			$t=0;
			for ($x=$start;$x<=$start+1;$x++) {
				$num_meta[$t]=$hexarray[$x];
				$t++;
			}
			$string_length[$y]=hexdec(join("",array_reverse($num_meta)));
			$start=$x;

			// String
			for ($x=$start; $x<=$start+$string_length[$y]-1; $x++) {
				$string[$y].=hex2bin($hexarray[$x]);
			}
			$start=$x;
			$return["value"][$y]=$string[$y];

		} elseif($type[$y]=="03") {
			unset ($num_meta);
			$t=0;
			for ($x=$start; $x<=$start+3; $x++) {
				$num_meta[$t]=$hexarray[$x];
				$t++;
			}
			$value[$y]=hexdec(join("",array_reverse($num_meta)));
			$start=$x;
			$return["value"][$y]=$value[$y];
		}
	}
	return $return;
}
?>
