#!/bin/sh
# $Id: install.sh,v 1.3 2002/06/22 10:07:02 schmitzj Exp $

echo "----------------------------------------------------------------"
cat <<eof
To install phpDonkey you need write access to the directorys
you specify as destination for the web (php) part and the
edonkey client!

It is also required that you have gcc and g++ installed - and
of course php, a web server and edonkey!

This install procedure will create a default installation with
default parameters. Fore changes or more features please edit
the file 'config.inc.php' in the directory where phpDonkey will
be installed (the exact path will be shown at the end).

eof
echo "----------------------------------------------------------------"

echo "Path to edonkey (without the programname itself eg. /home/user/)"
echo -n ":"
read donkeypath

echo "Path where edonkey stores its temp files (called tempdir in edonkey)"
echo -n ":"
read tempdir

echo "Where it your web dir (htdocs)? PhpDonkey will be copied there."
echo -n ":"
read htdocs

cat <<eof
Ok!

Now it's time to build some programs and copy all to its place,
please wait...

eof

mkdir $htdocs/phpDonkey && cp -R client/* $htdocs/phpDonkey && echo "PHP part installed"
cat >$htdocs/phpDonkey/config.inc.php <<eof
<?php
// both paths with slash at the end
\$donkeypath = "$donkeypath";
\$tempdir = "$tempdir";

// time between command and output (if you have problems on slow machines try "2" or "3")
// on very fast machines you can try 0.5 to 0.3
\$timefactor = 1;

// Realtime Display of Downloads (this has only effect on Internet-Explorer)
\$realtime="yes";

// Advanced Progress-Bars (see README on "How to activate?")
// Possible Values are "yes", "no", "php"
\$adv_progress = "yes";

// Appearance
\$face		= "arial";
\$bgcolor	= "#d7c39a";
\$fontcol	= "#572E33";
\$linkcol	= "#572E33";
\$vlinkcol	= "#572E33";
\$alinkcol	= "#877781";
\$fontsize	= "2";

// use additional stylesheet? (yes/no)
\$stylesheet = "yes";

// please don't change
\$logfile	= "d_out.log";
\$cfgServer	= "localhost";
\$cfgPort	= 8089;

require_once("serverlist.inc.php");
?>
eof

cd server
make
cp donk_serv logger $donkeypath
touch $donkeypath/d_out.log
chmod 666 $donkeypath/d_out.log

cd ../tools
make
cp info $donkeypath
chmod 777 $tempdir

cd ..
cat <<eof

Looks good!

You can start edonkey now with the program 'donk_serv' in the
edonkey directory ($donkeypath). 
You MUST NOT have edonkey already running and you should not 
start edonkey in another way.

To change phpDonkey settings edit the file
"$htdocs/phpDonkey/config.inc.php"
with your favorite editor (eg vi or nedit).

Have a nice day!

Hint for CVS users that want to have the latest changes:
If you got this release from the CVS tree you might simpley
go into the $htdocs/phpDonkey directory 
and do a 'cvs update' to get the latest php files with all 
their changes, fixes, improvments and new bugs!

eof
